# OpalTransportUDP Class Reference

`#include <transports.h>`

Inheritance diagram for OpalTransportUDP:

[legend]
Collaboration diagram for OpalTransportUDP:
[legend]

## Public Member Functions

Construction
| OpalTransportUDP (OpalEndPoint &endpoint, PIPSocket::Address binding=PIPSocket::GetDefaultIpAny(), WORD port=0, bool reuseAddr=false, bool preOpen=false)
| OpalTransportUDP (OpalEndPoint &endpoint, const PMonitoredSocketsPtr &sockets, const PString &iface)
| ~OpalTransportUDP ()
| Destroy the UDP channel.
Overides from class PChannel
virtual PBoolean | Read (void *buffer, PINDEX length)
Overides from class OpalTransport
virtual PBoolean | IsReliable () const
virtual PBoolean | IsCompatibleTransport (const OpalTransportAddress &address) const
virtual PBoolean | Connect ()
virtual PString | GetInterface () const
virtual bool | SetInterface (const PString &iface)
virtual OpalTransportAddress | GetLocalAddress (bool allowNAT=true) const
virtual PBoolean | SetLocalAddress (const OpalTransportAddress &address)
virtual PBoolean | SetRemoteAddress (const OpalTransportAddress &address)
virtual void | SetPromiscuous (PromisciousModes promiscuous)
virtual OpalTransportAddress | GetLastReceivedAddress () const
virtual PString | GetLastReceivedInterface () const
virtual PBoolean | ReadPDU (PBYTEArray &packet)
virtual PBoolean | WritePDU (const PBYTEArray &pdu)
virtual bool | WriteConnect (const WriteConnectCallback &function)
void | SetBufferSize (PINDEX size)

## Protected Member Functions

virtual const PCaselessString & | GetProtoPrefix () const

## Protected Attributes

OpalManager & | manager
PINDEX | m_bufferSize
PBYTEArray | m_preReadPacket
bool | m_preReadOK

## Friends

class | OpalListenerUDP

## Constructor & Destructor Documentation

OpalTransportUDP::OpalTransportUDP | ( | OpalEndPoint & | endpoint,
|  | PIPSocket::Address | binding = `PIPSocket::GetDefaultIpAny()`,
|  | WORD | port = `0`,
|  | bool | reuseAddr = `false`,
|  | bool | preOpen = `false` |
| ) |  |  |

Create a new transport channel.

Parameters:

  endpoint | Endpoint object
  binding | Local interface to use
  port | Local port to bind to
  reuseAddr | Flag for binding to already bound interface
  preOpen | Flag to pre-open socket

OpalTransportUDP::OpalTransportUDP | ( | OpalEndPoint & | endpoint,
|  | const PMonitoredSocketsPtr & | sockets,
|  | const PString & | iface |
| ) |  |  |

Create a new transport channel.

Parameters:

  endpoint | Endpoint object
  sockets | Bundle of sockets from OpalListenerUDP
  iface | Local interface to use

OpalTransportUDP::~OpalTransportUDP | ( |  | ) |

Destroy the UDP channel.

## Member Function Documentation

virtual PBoolean OpalTransportUDP::Connect | ( |  | ) | `[virtual]`

Connect to the remote party. This will createa a socket for each interface on the system, then the use of WriteConnect() will send out on every interface. ReadPDU() will return the first interface that has data, then the user can select which interface it wants by further calls to ReadPDU(). Once it has selected one it calls SetInterface() to finalise the selection process.

Implements OpalTransport.

virtual PString OpalTransportUDP::GetInterface | ( |  | ) | const`[virtual]`

Get the interface this transport is bound to.

Reimplemented from OpalTransport.

virtual OpalTransportAddress OpalTransportUDP::GetLastReceivedAddress | ( |  | ) | const`[virtual]`

Get the transport address of the last received PDU.

Default behaviour returns the lastReceivedAddress member variable.

Reimplemented from OpalTransport.

virtual PString OpalTransportUDP::GetLastReceivedInterface | ( |  | ) | const`[virtual]`

Get the interface of the last received PDU arrived on.

Default behaviour returns GetLocalAddress().

Reimplemented from OpalTransport.

virtual OpalTransportAddress OpalTransportUDP::GetLocalAddress | ( | bool | allowNAT = `true` | ) | const`[virtual]`

Get the transport dependent name of the local endpoint.

Parameters:

  allowNAT | Allow translation if remote needs NAT

Reimplemented from OpalTransportIP.

virtual const PCaselessString& OpalTransportUDP::GetProtoPrefix | ( |  | ) | const`[protected, virtual]`

Get the prefix for this transports protocol type.

Implements OpalTransportIP.

virtual PBoolean OpalTransportUDP::IsCompatibleTransport | ( | const OpalTransportAddress & | address | ) | const`[virtual]`

Check that the transport address is compatible with transport.

Implements OpalTransport.

virtual PBoolean OpalTransportUDP::IsReliable | ( |  | ) | const`[virtual]`

Get indication of the type of underlying transport.

Implements OpalTransport.

virtual PBoolean OpalTransportUDP::Read | ( | void * | buffer,
|  | PINDEX | length |
| ) |  |  | `[virtual]`

virtual PBoolean OpalTransportUDP::ReadPDU | ( | PBYTEArray & | packet | ) | `[virtual]`

Read a protocol data unit from the transport. This will read using the transports mechanism for PDU boundaries, for example UDP is a single Read() call, while for TCP there is a TPKT header that indicates the size of the PDU.

If false is returned but there is data returned in the `packet` that indicates that the available buffer space was too small, e.g. an EMSGSIZE error was returned by recvfrom.

Parameters:

  packet | Packet read from transport

Implements OpalTransport.

void OpalTransportUDP::SetBufferSize | ( | PINDEX | size | ) | `[inline]`

Set the size of UDP packet reads.

virtual bool OpalTransportUDP::SetInterface | ( | const PString & | iface | ) | `[virtual]`

Bind this transport to an interface. This is generally only relevant for datagram based transports such as UDP and TCP is always bound to a local interface once open.

The default behaviour does nothing.

Parameters:

  iface | Interface to use

Reimplemented from OpalTransport.

virtual PBoolean OpalTransportUDP::SetLocalAddress | ( | const OpalTransportAddress & | address | ) | `[virtual]`

Set local address to connect from. Note that this may not work for all transport types or may work only before Connect() has been called.

Reimplemented from OpalTransportIP.

virtual void OpalTransportUDP::SetPromiscuous | ( | PromisciousModes | promiscuous | ) | `[virtual]`

Set read to promiscuous mode. Normally only reads from the specifed remote address are accepted. This flag allows packets to be accepted from any remote, provided the underlying protocol can do so.

The Read() call may optionally set the remote address automatically to whatever the sender host of the last received message was.

Default behaviour sets the internal flag, so that Read() operates as described.

virtual PBoolean OpalTransportUDP::SetRemoteAddress | ( | const OpalTransportAddress & | address | ) | `[virtual]`

Set remote address to connect to. Note that this does not necessarily initiate a transport level connection, but only indicates where to connect to. The actual connection is made by the Connect() function.

Reimplemented from OpalTransportIP.

virtual bool OpalTransportUDP::WriteConnect | ( | const WriteConnectCallback & | function | ) | `[virtual]`

Write the first packet to the transport, after a connect. This will adjust the transport object and call the callback function, possibly multiple times for some transport types.

It is expected that this is used just after a Connect() call where some transports (eg UDP) cannot determine its local address which is required in the PDU to be sent. This must be done fer each interface so WriteConnect() calls WriteConnectCallback for each interface. The subsequent ReadPDU() returns the answer from the first interface.

Parameters:

  function | Function for writing data

virtual PBoolean OpalTransportUDP::WritePDU | ( | const PBYTEArray & | pdu | ) | `[virtual]`

Write a packet to the transport. This will write using the transports mechanism for PDU boundaries, for example UDP is a single Write() call, while for TCP there is a TPKT header that indicates the size of the PDU.

Parameters:

  pdu | Packet to write

Implements OpalTransport.

## Friends And Related Function Documentation

friend class OpalListenerUDP `[friend]`

## Field Documentation

PINDEX OpalTransportUDP::m_bufferSize `[protected]`

bool OpalTransportUDP::m_preReadOK `[protected]`

PBYTEArray OpalTransportUDP::m_preReadPacket `[protected]`

OpalManager& OpalTransportUDP::manager `[protected]`

The documentation for this class was generated from the following file:

- transports.h